/*
Copyright (c) 2016-2017 Bitnami

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// This file was automatically generated by informer-gen

package v1beta1

import (
	internalinterfaces "github.com/kubeless/kubeless/pkg/client/informers/externalversions/internalinterfaces"
)

// Interface provides access to all the informers in this group version.
type Interface interface {
	// CronJobTriggers returns a CronJobTriggerInformer.
	CronJobTriggers() CronJobTriggerInformer
	// Functions returns a FunctionInformer.
	Functions() FunctionInformer
	// HTTPTriggers returns a HTTPTriggerInformer.
	HTTPTriggers() HTTPTriggerInformer
	// KafkaTriggers returns a KafkaTriggerInformer.
	KafkaTriggers() KafkaTriggerInformer
	// KinesisTriggers returns a KinesisTriggerInformer.
	KinesisTriggers() KinesisTriggerInformer
	// NATSTriggers returns a NATSTriggerInformer.
	NATSTriggers() NATSTriggerInformer
}

type version struct {
	factory          internalinterfaces.SharedInformerFactory
	namespace        string
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// New returns a new Interface.
func New(f internalinterfaces.SharedInformerFactory, namespace string, tweakListOptions internalinterfaces.TweakListOptionsFunc) Interface {
	return &version{factory: f, namespace: namespace, tweakListOptions: tweakListOptions}
}

// CronJobTriggers returns a CronJobTriggerInformer.
func (v *version) CronJobTriggers() CronJobTriggerInformer {
	return &cronJobTriggerInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// Functions returns a FunctionInformer.
func (v *version) Functions() FunctionInformer {
	return &functionInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// HTTPTriggers returns a HTTPTriggerInformer.
func (v *version) HTTPTriggers() HTTPTriggerInformer {
	return &hTTPTriggerInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// KafkaTriggers returns a KafkaTriggerInformer.
func (v *version) KafkaTriggers() KafkaTriggerInformer {
	return &kafkaTriggerInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// KinesisTriggers returns a KinesisTriggerInformer.
func (v *version) KinesisTriggers() KinesisTriggerInformer {
	return &kinesisTriggerInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NATSTriggers returns a NATSTriggerInformer.
func (v *version) NATSTriggers() NATSTriggerInformer {
	return &nATSTriggerInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}
